@echo off
REM EQU=Equal
REM NEQ=!Equal
REM LSS=Less
REM LEQ=Less or Equal
REM GTR=Greather then
REM GEQ=Greather or Equal then
REM ERRORLEVEL 1/0
rem CHRISSSTRAHL
cls
color 0B
title=Elite Force II Master Server Fix
echo.
echo ----------------------------------------------
echo Welcome!
echo This tool will try to modify your System-File "hosts",
echo adding or removing the redirect to the alternative Master Server.
echo.
echo 1. You might need to start this tool with administrative privileges.
echo 2. You probably need to grant permission for this tool to
echo    modify the System-File "hosts", as it might be protected
echo    by a Security Software or the Operating System it self.
echo ----------------------------------------------
echo.
echo PRESS ANY KEY, WHEN READY TO PROCEED
pause >NUL

set hostsfileloc=%systemroot%\System32\drivers\etc\hosts

echo.
cls
echo ----------------------------------------------
if not exist %hostsfileloc% goto error1
echo The tool is trying to read your "hosts" file
echo to see if the new Master Server is already set.
echo ----------------------------------------------
echo.
echo PRESS ANY KEY, WHEN READY TO PROCEED
pause >NUL


cls
echo READING FILE...
echo.
findstr	/I ef2master.activision.com %hostsfileloc%
If %ERRORLEVEL% EQU 0 goto masterAllreadySet


echo -------------------------------NO ENTRY FOUND!
echo The tool will try now to write the following entry
echo into your "hosts" file:
echo.
echo  # NEW EF2 Master Server - Routing entry below
echo 78.46.64.6		ef2master.activision.com
echo ----------------------------------------------
echo.
echo PRESS ANY KEY, WHEN READY TO PROCEED
pause >NUL

cls
echo ----------------------------------------------
echo 1. Trying to change file attributes to writeable
@attrib -r %hostsfileloc%
If %ERRORLEVEL% EQU 0 echo - Succeeded
echo 2. Trying to overwrite the "hosts" file
@echo  # NEW EF2 Master Server - Routing entry below>>%hostsfileloc%
@echo 78.46.64.6		ef2master.activision.com>>%hostsfileloc%
If %ERRORLEVEL% EQU 0 echo - Succeeded
echo 1. Trying to change file attributes to NOT writeable
@attrib +r %hostsfileloc%
If %ERRORLEVEL% EQU 0 echo - Succeeded
echo --------------------------PROCESS IS COMPLETE!
echo.
echo PRESS ANY KEY TO EXIT
pause >NUL

:masterGsio
cls
echo.
echo.
echo.
echo ----------------------------------------------
echo Thanks to GSIO for providing us a new Master Server!
echo http://ef2master.hennecke-online.net/
echo.
echo Thanks to batti-batch for the code of the replace routine
echo.
echo This tool was created for ritualistic.com, feel free to share it
echo ----------------------------------------------
echo.
echo If it does NOT WORK, please REBOOT your system.
pause >NUL
exit

:masterAllreadySet
echo ----------------------------------------------
echo ENTRY DOES ALREADY EXIST
echo ----------------------------------------------
echo.
echo 1 = Remove entry and restore to default
echo 2 = Exit
set remove=0
set /p remove=
if %remove% == 1 goto restoreToDefault
goto masterGsio


:restoreToDefault
cls
echo ----------------------------------------------
echo RESTORING TO DEFAULT
echo ----------------------------------------------
echo.
rem  # NEW EF2 Master Server - Routing entry below"
rem 78.46.64.6		ef2master.activision.com"

if exist %systemroot%\System32\drivers\etc\hosts.bak goto skipBackup
:skipBackup
echo 1. Backup (hosts.bak) does allready exist, skipping...
goto replaceProcedure1

:createBackup
echo 1. Creating Backup: hosts.bak
copy /Y %hostsfileloc% %systemroot%\System32\drivers\etc\hosts.bak /V

:replaceProcedure1
echo 2. Deleting matching strings (creating temp files)

REM Testprogramm
REM Suchen und Ersetzen in einer Textdatei
REM
REM http://www.supportnet.de/threads/1481757
REM batti-batch 11/2007
REM
REM lauffaehig ab Windows 2000
rem TAKEN FROM http://www.supportnet.de/fresh/2007/1/id1481757.asp
SETLOCAL enabledelayedexpansion
SET "quell_datei=%systemroot%\System32\drivers\etc\hosts"
SET "ziel_datei=%systemroot%\System32\drivers\etc\hosts2"
SET "suchen_nach=78.46.64.6		ef2master.activision.com"
SET "ersetzen_durch="

IF EXIST %ziel_datei% (DEL /f %ziel_datei% 1>NUL 2>NUL)
FOR /f "delims=" %%i IN ('FINDSTR . "%quell_datei%"') DO (
SET zeile=%%i& CALL :ersetzen1 !zeile!
)
GOTO :weiter1
:ersetzen1
SET zeile=!zeile:%suchen_nach%=%ersetzen_durch%!
IF [!zeile!] EQU [] (ECHO.>>%ziel_datei%) ELSE (ECHO !zeile!>>%ziel_datei%)
GOTO :eof
:weiter1

SET "quell_datei=%systemroot%\System32\drivers\etc\hosts2"
SET "ziel_datei=%systemroot%\System32\drivers\etc\hosts3"
SET "suchen_nach= # NEW EF2 Master Server - Routing entry below"
SET "ersetzen_durch="

IF EXIST %ziel_datei% (DEL /f %ziel_datei% 1>NUL 2>NUL)
FOR /f "delims=" %%i IN ('FINDSTR . "%quell_datei%"') DO (
SET zeile=%%i& CALL :ersetzen2 !zeile!
)
GOTO :weiter2
:ersetzen2
SET zeile=!zeile:%suchen_nach%=%ersetzen_durch%!
IF [!zeile!] EQU [] (ECHO.>>%ziel_datei%) ELSE (ECHO !zeile!>>%ziel_datei%)
GOTO :eof
:weiter2
:eof
echo 3. Overwriting "hosts" with temporary file "hosts3"
@attrib -r %hostsfileloc%
copy /Y %systemroot%\System32\drivers\etc\hosts3 %hostsfileloc% /V
@attrib +r %hostsfileloc%

echo 4. Deleting temporary files: hosts2, hosts3
del /F %systemroot%\System32\drivers\etc\hosts2
del /F %systemroot%\System32\drivers\etc\hosts3

echo.
echo ----------------------------------------------
echo DEFAULT RESTORED
echo ----------------------------------------------
echo.
echo PRESS ANY KEY, WHEN READY TO PROCEED
pause >NUL
goto masterGsio

:error1
cls
echo.
echo ----------------------------------------------
echo I'm sorry the tool can not find the file "hosts" on your system.
echo Contact us: http://hazardmodding.chrissstrahl.de/?content=contact
echo ----------------------------------------------
echo.
echo - To use our contact form press 1 and hit enter
echo - Hit enter without pressing 1 to exit the tool now
set opensite=0
set /p opensite=
if %opensite% == 1 goto openwebsite
goto masterGsio

:openwebsite
cls
echo.
echo The tool is now creating a URL-file and calling it,
echo in order to open the website with your default Webbrowser.
if exist ef2_hzm_contact.url goto callurl
echo [InternetShortcut]>>	ef2_hzm_contact.url
echo URL=http://hazardmodding.chrissstrahl.de/?content=contact	>>ef2_hzm_contact.url
echo HotKey=0	>>ef2_hzm_contact.url
echo IconFile=%systemroot%\system32\shell32.dll	>>ef2_hzm_contact.url
echo IconIndex=13	>>ef2_hzm_contact.url
echo.
:callurl
echo File created - PRESS ANY KEY to vist the website
pause >NUL
cls
echo.
call ef2_hzm_contact.url
echo Trying to delete "ef2_hzm_contact.url" before exiting this tool
@del ef2_hzm_contact.url
exit
